/* Generated By:JavaCC: Do not edit this line. ESFParser.java */
package org.lwes.db;

import java.math.BigInteger;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.lwes.FieldType;
import org.lwes.util.IPAddress;

@SuppressWarnings("all") public class ESFParser implements ESFParserConstants {

    private static transient Log log = LogFactory.getLog(ESFParser.class);

  private String currentEvent;
  private EventTemplateDB eventTemplateDB;

  private StringBuilder commentAccumulator = new StringBuilder();

  public void setEventTemplateDB(EventTemplateDB DB)
    { eventTemplateDB = DB; }

  public EventTemplateDB getEventTemplateDB()
    { return eventTemplateDB; }

  public void setCurrentEvent(String evt)
    { currentEvent = evt; }

  public String getCurrentEvent()
    { return currentEvent; }

  public String removeQuotes(String str) {
    return str.replace("\u005c"","");
  }

/**
 * A list of events
 */
  final public void eventlist() throws ParseException {
    String aComment = null;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SINGLE_LINE_COMMENT:
      case ID:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      if (jj_2_1(2147483647)) {
        comment();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SINGLE_LINE_COMMENT:
        case ID:
          label_2:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SINGLE_LINE_COMMENT:
              ;
              break;
            default:
              jj_la1[1] = jj_gen;
              break label_2;
            }
            aComment = comment();
          }
          event();
          break;
        default:
          jj_la1[2] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    jj_consume_token(0);
  }

/**
 * a single event
 */
  final public void event() throws ParseException {
    eventName();
    jj_consume_token(19);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SINGLE_LINE_COMMENT:
    case REQ:
    case NULLABLE:
    case OPT:
    case ID:
      attributeList();
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
    jj_consume_token(20);
  }

/**
 * The name of an event, should be max 256 chars ([a-zA-Z0-9_]*)
 */
  final public void eventName() throws ParseException {
  Token t;
    t = jj_consume_token(ID);
    if (getEventTemplateDB().addEvent(t.image,commentAccumulator.toString()))
    {
      commentAccumulator.setLength(0);
      setCurrentEvent(t.image);
    }
    else
    {
      {if (true) throw new ParseException("Problem adding event "+t.image);}
    }
  }

  final public void attributeList() throws ParseException {
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SINGLE_LINE_COMMENT:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_3;
      }
      comment();
    }
    attribute();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REQ:
      case NULLABLE:
      case OPT:
      case ID:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_4;
      }
      attribute();
    }
  }

  final public String stringLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(STRING_LITERAL);
       {if (true) return removeQuotes(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public boolean booleanLiteral() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
    {if (true) return true;}
      break;
    case FALSE:
      jj_consume_token(FALSE);
    {if (true) return false;}
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public int integerLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(INTEGER_LITERAL);
    try {
      {if (true) return Integer.parseInt(t.image);}
    } catch (NumberFormatException e) {
      {if (true) throw new Error();}
    }
    throw new Error("Missing return statement in function");
  }

  final public BigInteger bigIntegerLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(BIG_INTEGER_LITERAL);
    {if (true) return new BigInteger(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public IPAddress ipaddrLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(IPADDR_LITERAL);
    {if (true) return new IPAddress(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public double doubleLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(DOUBLE_LITERAL);
       try {
         {if (true) return Double.parseDouble(t.image);}
       } catch (NumberFormatException e) {
         {if (true) throw new Error();}
       }
    throw new Error("Missing return statement in function");
  }

  final public Object defaultValue() throws ParseException {
    Object obj;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      obj = integerLiteral();
      {if (true) return obj;}
      break;
    case BIG_INTEGER_LITERAL:
      obj = bigIntegerLiteral();
      {if (true) return obj;}
      break;
    case DOUBLE_LITERAL:
      obj = doubleLiteral();
      {if (true) return obj;}
      break;
    case TRUE:
    case FALSE:
      obj = booleanLiteral();
      {if (true) return obj;}
      break;
    case STRING_LITERAL:
      obj = stringLiteral();
      {if (true) return obj;}
      break;
    case IPADDR_LITERAL:
      obj = ipaddrLiteral();
      {if (true) return obj;}
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public boolean required() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REQ:
      jj_consume_token(REQ);
      {if (true) return true;}
      break;
    case OPT:
      jj_consume_token(OPT);
      {if (true) return false;}
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public boolean nullable() throws ParseException {
    jj_consume_token(NULLABLE);
      {if (true) return true;}
    throw new Error("Missing return statement in function");
  }

  final public void attribute() throws ParseException {
  FieldType aType;
  String anAttribute;
  int anArraySize = 0;
  boolean required = false;
  boolean nullable = false;
  Object aDefaultValue = null;
  String aComment = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REQ:
    case OPT:
      required = required();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NULLABLE:
        nullable = nullable();
        break;
      default:
        jj_la1[9] = jj_gen;
        ;
      }
      aType = type();
      anAttribute = attributeName();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        jj_consume_token(LBRACKET);
        anArraySize = integerLiteral();
        jj_consume_token(RBRACKET);
        break;
      default:
        jj_la1[10] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 21:
        jj_consume_token(21);
        aDefaultValue = defaultValue();
        break;
      default:
        jj_la1[11] = jj_gen;
        ;
      }
      jj_consume_token(22);
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SINGLE_LINE_COMMENT:
          ;
          break;
        default:
          jj_la1[12] = jj_gen;
          break label_5;
        }
        aComment = comment();
      }
      break;
    case NULLABLE:
    case ID:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NULLABLE:
        nullable = nullable();
        break;
      default:
        jj_la1[13] = jj_gen;
        ;
      }
      aType = type();
      anAttribute = attributeName();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        jj_consume_token(LBRACKET);
        anArraySize = integerLiteral();
        jj_consume_token(RBRACKET);
        break;
      default:
        jj_la1[14] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 21:
        jj_consume_token(21);
        aDefaultValue = defaultValue();
        break;
      default:
        jj_la1[15] = jj_gen;
        ;
      }
      jj_consume_token(22);
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SINGLE_LINE_COMMENT:
          ;
          break;
        default:
          jj_la1[16] = jj_gen;
          break label_6;
        }
        aComment = comment();
      }
      break;
    default:
      jj_la1[17] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      String evt = getCurrentEvent();
      if ( evt == null ) {if (true) throw new ParseException("Bad Event");}

      if (log.isTraceEnabled()) {
        log.trace("Type: "+aType+" attr: "+anAttribute+" size: "+anArraySize);
        log.trace("Required: "+required+" nullable: "+nullable);
        log.trace("default value: "+aDefaultValue);
      }

      if (nullable && anArraySize == 0) {
        {if (true) throw new ParseException("nullable keyword is only valid for arrays");}
      }

      if (anArraySize > 0) {
        if (nullable) {
          aType = aType.getNullableArrayType();
        } else {
          aType = aType.getArrayType();
        }
      }

      if ( !getEventTemplateDB().addEventAttribute(evt,
                                                   anAttribute,
                                                   aType,
                                                   anArraySize,
                                                   required,
                                                   aDefaultValue,
                                                                           commentAccumulator.toString()
                ))
      {
        {if (true) throw new ParseException("Problem adding attribute "+evt+"("
                                 +aType+","+anAttribute+")");}
      }
      // after comment is stored, reset accumulator
      commentAccumulator.setLength(0);
  }

  final public FieldType type() throws ParseException {
  Token t;
    t = jj_consume_token(ID);
    {if (true) return FieldType.byName(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public String attributeName() throws ParseException {
  Token t;
    t = jj_consume_token(ID);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  final public String comment() throws ParseException {
    Token t;
    t = jj_consume_token(SINGLE_LINE_COMMENT);
    commentAccumulator.append(t.image);
    {if (true) return commentAccumulator.toString();}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_3R_8() {
    if (jj_scan_token(SINGLE_LINE_COMMENT)) return true;
    return false;
  }

  private boolean jj_3R_7() {
    if (jj_3R_8()) return true;
    return false;
  }

  private boolean jj_3_1() {
    Token xsp;
    if (jj_3R_7()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_7()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(0)) return true;
    return false;
  }

  /** Generated Token Manager. */
  public ESFParserTokenManager token_source;
  JavaCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[18];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x40020,0x20,0x40020,0x401e0,0x20,0x401c0,0x600,0x3e600,0x140,0x80,0x800,0x200000,0x20,0x80,0x800,0x200000,0x20,0x401c0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[1];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public ESFParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public ESFParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new JavaCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ESFParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public ESFParser(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new ESFParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public ESFParser(ESFParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(ESFParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[23];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 18; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 1; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
